package org.yaoqiang.collaboration.dialog;

import org.yaoqiang.collaboration.MainPanel;
import org.yaoqiang.dialog.BaseDialog;
import org.yaoqiang.dialog.Panel;
import org.yaoqiang.util.Resources;


/**
 * CollaborationDialog
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class CollaborationDialog extends BaseDialog {

	private static final long serialVersionUID = -3312463408713700418L;

	protected MainPanel mainPanel;

	public CollaborationDialog(MainPanel mainPanel) {
		this.mainPanel = mainPanel;
	}

	public CollaborationDialog initDialog() {
		return (CollaborationDialog) super.initDialog();
	}

	public CollaborationDialog initDialog(String optButton) {
		return (CollaborationDialog) super.initDialog(optButton);
	}

	public CollaborationDialog initDialog(boolean save) {
		return (CollaborationDialog) super.initDialog(save);
	}

	public CollaborationDialog initDialog(boolean save, String okButton) {
		return (CollaborationDialog) super.initDialog(save, okButton);
	}

	public CollaborationPanel getParentPanel() {
		return (CollaborationPanel) parentPanel;
	}

	public MainPanel getMainPanel() {
		return mainPanel;
	}

	public void editObject(Object obj) {
		editObject(null, obj, "");
	}

	public void editObject(Object obj, String type) {
		editObject(null, obj, type);
	}

	public void editObject(Panel parentPanel, Object obj, String type) {
		this.parentPanel = parentPanel;
		panelContainer.setActiveObject(obj, type);
		setTitle(Resources.get(type));
		setDialogVisible();
	}

	protected void init() {
		panelContainer = new CollaborationPanelContainer(this);
	}

	public void save() {
		panelContainer.apply();
		dispose();
	}

	public void close() {
		if (panelContainer.isModified() && save) {
			panelContainer.showModifiedWarning();
		}
		setVisible(false);
		dispose();
	}

}
